Virtual Machine Scale Set VMs - Get Instance View
Gets the status of a virtual machine from a VM scale set.
GET https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualMachines/{instanceId}/instanceView?api-version=2026-04-01
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
instance
|
path | True |
string |
The instance ID of the virtual machine. |
|
resource
|
path | True |
string minLength: 1maxLength: 90 |
The name of the resource group. The name is case insensitive. |
|
subscription
|
path | True |
string minLength: 1 |
The ID of the target subscription. |
|
vm
|
path | True |
string |
The name of the VM scale set. |
|
api-version
|
query | True |
string minLength: 1 |
The API version to use for this operation. |
Responses
| Name | Type | Description |
|---|---|---|
| 200 OK |
Azure operation completed successfully. |
|
| Other Status Codes |
An unexpected error response. |
Security
azure_auth
Azure Active Directory OAuth2 Flow.
Type:
oauth2
Flow:
implicit
Authorization URL:
https://login.microsoftonline.com/common/oauth2/authorize
Scopes
| Name | Description |
|---|---|
| user_impersonation | impersonate your user account |
Examples
Get instance view of a virtual machine from a VM scale set placed on a dedicated host group through automatic placement.
Sample request
GET https://management.azure.com/subscriptions/{subscription-id}/resourceGroups/myResourceGroup/providers/Microsoft.Compute/virtualMachineScaleSets/myVirtualMachineScaleSet/virtualMachines/0/instanceView?api-version=2026-04-01
Sample response
{
"platformUpdateDomain": 0,
"platformFaultDomain": 0,
"rdpThumbPrint": null,
"vmAgent": {
"vmAgentVersion": "Unknown",
"statuses": [
{
"code": "ProvisioningState/Unavailable",
"level": "Warning",
"displayStatus": "Not Ready",
"message": "VM status blob is found but not yet populated.",
"time": "2026-04-01T05:00:32+00:00"
}
],
"extensionHandlers": null
},
"disks": [
{
"name": "myOSDisk",
"encryptionSettings": null,
"statuses": [
{
"code": "ProvisioningState/succeeded",
"level": "Info",
"displayStatus": "Provisioning succeeded",
"message": null,
"time": "2026-04-01T04:58:58.0882815+00:00"
}
]
}
],
"extensions": null,
"assignedHost": "/subscriptions/{subscription-id}/resourceGroups/myResourceGroup/providers/Microsoft.Compute/hostGroups/myHostGroup/hosts/myHost",
"bootDiagnostics": null,
"statuses": [
{
"code": "ProvisioningState/succeeded",
"level": "Info",
"displayStatus": "Provisioning succeeded",
"message": null,
"time": "2020-06-05T04:59:58.1852966+00:00"
},
{
"code": "PowerState/running",
"level": "Info",
"displayStatus": "VM running",
"message": null,
"time": null
}
]
}
Get instance view of a virtual machine from a VM scale set that is eligible for and consuming an open capacity reservation.
Sample request
GET https://management.azure.com/subscriptions/{subscription-id}/resourceGroups/myResourceGroup/providers/Microsoft.Compute/virtualMachineScaleSets/myVirtualMachineScaleSet/virtualMachines/0/instanceView?api-version=2026-04-01
Sample response
{
"platformUpdateDomain": 0,
"platformFaultDomain": 0,
"rdpThumbPrint": null,
"vmAgent": {
"vmAgentVersion": "2.7.41491.1010",
"statuses": [
{
"code": "ProvisioningState/succeeded",
"level": "Info",
"displayStatus": "Ready",
"message": "GuestAgent is running and processing the extensions.",
"time": "2026-04-01T05:00:32+00:00"
}
],
"extensionHandlers": null
},
"disks": [
{
"name": "myOSDisk",
"encryptionSettings": null,
"statuses": [
{
"code": "ProvisioningState/succeeded",
"level": "Info",
"displayStatus": "Provisioning succeeded",
"message": null,
"time": "2026-04-01T04:58:58.0882815+00:00"
}
]
}
],
"extensions": null,
"bootDiagnostics": null,
"capacityReservationType": "Open",
"statuses": [
{
"code": "ProvisioningState/succeeded",
"level": "Info",
"displayStatus": "Provisioning succeeded",
"message": null,
"time": "2026-04-01T04:59:58.1852966+00:00"
},
{
"code": "PowerState/running",
"level": "Info",
"displayStatus": "VM running",
"message": null,
"time": null
}
]
}
Definitions
| Name | Description |
|---|---|
|
Api |
Api error. |
|
Api |
Api error base. |
|
Boot |
The instance view of a virtual machine boot diagnostics. |
|
Capacity |
Specifies which type of capacity reservation the virtual machine will consume capacity from if eligible or whether it is explicitly opted out from being associated and consuming capacity from any reserved capacity available in the subscription. Minimum api-version: 2026-04-01. |
|
Cloud |
An error response from the Compute service. |
|
Disk |
Describes a Encryption Settings for a Disk |
|
Disk |
The instance view of the disk. |
|
Hyper |
The hypervisor generation of the Virtual Machine [V1, V2] |
|
Inner |
Inner error details. |
|
Instance |
Instance view status. |
|
Interconnect |
The Interconnect Block instance view details for a Virtual Machine or Scale Set VM instance. |
|
Key |
Describes a reference to Key Vault Key |
|
Key |
Describes a reference to Key Vault Secret |
|
Maintenance |
The Last Maintenance Operation Result Code. |
|
Maintenance |
Maintenance Operation Status. |
|
Status |
The level code. |
|
Storage |
Specifies the storage alignment status for the disk. |
|
Sub |
|
|
Virtual |
The instance view of the VM Agent running on the virtual machine. |
|
Virtual |
The instance view of a virtual machine extension handler. |
|
Virtual |
The instance view of a virtual machine extension. |
|
Virtual |
The health status of the VM. |
|
Virtual |
The instance view of a virtual machine scale set VM. |
ApiError
Api error.
| Name | Type | Description |
|---|---|---|
| code |
string |
The error code. |
| details |
The Api error details |
|
| innererror |
The Api inner error |
|
| message |
string |
The error message. |
| target |
string |
The target of the particular error. |
ApiErrorBase
Api error base.
| Name | Type | Description |
|---|---|---|
| code |
string |
The error code. |
| message |
string |
The error message. |
| target |
string |
The target of the particular error. |
BootDiagnosticsInstanceView
The instance view of a virtual machine boot diagnostics.
| Name | Type | Description |
|---|---|---|
| consoleScreenshotBlobUri |
string |
The console screenshot blob URI. Note: This will not be set if boot diagnostics is currently enabled with managed storage. |
| serialConsoleLogBlobUri |
string |
The serial console log blob Uri. Note: This will not be set if boot diagnostics is currently enabled with managed storage. |
| status |
The boot diagnostics status information for the VM. Note: It will be set only if there are errors encountered in enabling boot diagnostics. |
CapacityReservationType
Specifies which type of capacity reservation the virtual machine will consume capacity from if eligible or whether it is explicitly opted out from being associated and consuming capacity from any reserved capacity available in the subscription. Minimum api-version: 2026-04-01.
| Value | Description |
|---|---|
| NotEligible |
The virtual machine is not eligible to be implicitly associated with an open capacity reservation and is not explicitly associated with any capacity reservation group, so it will consume capacity from the publicly available capacity. |
| Targeted |
The virtual machine will consume capacity from a specific matching capacity reservation when associated with a capacity reservation group resource of type targeted, but can fall back to consume capacity from the publicly available capacity if there is no capacity available in the targeted reservation. |
| Open |
The virtual machine if eligible will implicitly associate and consume any available capacity from a matching open capacity reservation created or shared in the subscription. Note: The VM should not be explicitly associated with the open capacity reservation group resource containing the matching reservation. |
| Disabled |
The virtual machine has capacity reservation assignment disabled and will not be allowed to implicitly or explicitly associate with any type of capacity reservation. |
| Block |
The virtual machine consumes capacity from a specific matching capacity reservation when associated with a capacity reservation group resource of type block, and will hit capacity failures if there is no available capacity in the block reservation. |
CloudError
An error response from the Compute service.
| Name | Type | Description |
|---|---|---|
| error |
Api error. |
DiskEncryptionSettings
Describes a Encryption Settings for a Disk
| Name | Type | Description |
|---|---|---|
| diskEncryptionKey |
Specifies the location of the disk encryption key, which is a Key Vault Secret. |
|
| enabled |
boolean |
Specifies whether disk encryption should be enabled on the virtual machine. |
| keyEncryptionKey |
Specifies the location of the key encryption key in Key Vault. |
DiskInstanceView
The instance view of the disk.
| Name | Type | Description |
|---|---|---|
| encryptionSettings |
Specifies the encryption settings for the OS Disk. |
|
| name |
string |
The disk name. |
| statuses |
The resource status information. |
|
| storageAlignmentStatus |
Specifies the storage alignment status for the disk. |
HyperVGeneration
The hypervisor generation of the Virtual Machine [V1, V2]
| Value | Description |
|---|---|
| V1 | |
| V2 |
InnerError
Inner error details.
| Name | Type | Description |
|---|---|---|
| errordetail |
string |
The internal error message or exception dump. |
| exceptiontype |
string |
The exception type. |
InstanceViewStatus
Instance view status.
| Name | Type | Description |
|---|---|---|
| code |
string |
The status code. |
| displayStatus |
string |
The short localizable label for the status. |
| level |
The level code. |
|
| message |
string |
The detailed status message, including for alerts and error messages. |
| time |
string (date-time) |
The time of the status. |
InterconnectInstanceView
The Interconnect Block instance view details for a Virtual Machine or Scale Set VM instance.
| Name | Type | Description |
|---|---|---|
| interconnectSubgroupId |
string |
The ID (GUID) of the Interconnect subgroup in which the Virtual Machine was placed. |
KeyVaultKeyReference
Describes a reference to Key Vault Key
| Name | Type | Description |
|---|---|---|
| keyUrl |
string |
The URL referencing a key encryption key in Key Vault. |
| sourceVault |
The relative URL of the Key Vault containing the key. |
KeyVaultSecretReference
Describes a reference to Key Vault Secret
| Name | Type | Description |
|---|---|---|
| secretUrl |
string |
The URL referencing a secret in a Key Vault. |
| sourceVault |
The relative URL of the Key Vault containing the secret. |
MaintenanceOperationResultCodeTypes
The Last Maintenance Operation Result Code.
| Value | Description |
|---|---|
| None | |
| RetryLater | |
| MaintenanceAborted | |
| MaintenanceCompleted |
MaintenanceRedeployStatus
Maintenance Operation Status.
| Name | Type | Description |
|---|---|---|
| isCustomerInitiatedMaintenanceAllowed |
boolean |
True, if customer is allowed to perform Maintenance. |
| lastOperationMessage |
string |
Message returned for the last Maintenance Operation. |
| lastOperationResultCode |
The Last Maintenance Operation Result Code. |
|
| maintenanceWindowEndTime |
string (date-time) |
End Time for the Maintenance Window. |
| maintenanceWindowStartTime |
string (date-time) |
Start Time for the Maintenance Window. |
| preMaintenanceWindowEndTime |
string (date-time) |
End Time for the Pre Maintenance Window. |
| preMaintenanceWindowStartTime |
string (date-time) |
Start Time for the Pre Maintenance Window. |
StatusLevelTypes
The level code.
| Value | Description |
|---|---|
| Info | |
| Warning | |
| Error |
StorageAlignmentStatus
Specifies the storage alignment status for the disk.
| Value | Description |
|---|---|
| Unaligned |
Disk does not have Storage Fault Domain to Compute Fault Domain mapping. A single Storage Fault Domain failure may impact all VMs that reference this disk profile. |
| Aligned |
Disk has Storage Fault Domain to Compute Fault Domain mapping. Storage Fault Domain failure is contained to VMs in a single Compute Fault Domain. |
SubResource
| Name | Type | Description |
|---|---|---|
| id |
string |
Resource Id |
VirtualMachineAgentInstanceView
The instance view of the VM Agent running on the virtual machine.
| Name | Type | Description |
|---|---|---|
| extensionHandlers |
The virtual machine extension handler instance view. |
|
| statuses |
The resource status information. |
|
| vmAgentVersion |
string |
The VM Agent full version. |
VirtualMachineExtensionHandlerInstanceView
The instance view of a virtual machine extension handler.
| Name | Type | Description |
|---|---|---|
| status |
The extension handler status. |
|
| type |
string |
Specifies the type of the extension; an example is "CustomScriptExtension". |
| typeHandlerVersion |
string |
Specifies the Major.Minor.Patch.Hotfix version of the script handler. Azure platform will deliver the latest Patch.Hotfix version in the Major.Minor series. |
VirtualMachineExtensionInstanceView
The instance view of a virtual machine extension.
| Name | Type | Description |
|---|---|---|
| name |
string |
The virtual machine extension name. |
| statuses |
The resource status information. |
|
| substatuses |
The resource status information. |
|
| type |
string |
Specifies the type of the extension; an example is "CustomScriptExtension". |
| typeHandlerVersion |
string |
Specifies the Major.Minor.Patch.Hotfix version of the script handler. Azure platform will deliver the latest Patch.Hotfix version in the Major.Minor series. |
VirtualMachineHealthStatus
The health status of the VM.
| Name | Type | Description |
|---|---|---|
| status |
The health status information for the VM. |
VirtualMachineScaleSetVMInstanceView
The instance view of a virtual machine scale set VM.
| Name | Type | Description |
|---|---|---|
| assignedHost |
string |
Resource id of the dedicated host, on which the virtual machine is allocated through automatic placement, when the virtual machine is associated with a dedicated host group that has automatic placement enabled. Minimum api-version: 2020-06-01. |
| bootDiagnostics |
Boot Diagnostics is a debugging feature which allows you to view Console Output and Screenshot to diagnose VM status. You can easily view the output of your console log. Azure also enables you to see a screenshot of the VM from the hypervisor. |
|
| capacityReservationType |
Specifies which type of capacity reservation the virtual machine scale set VM instance will consume capacity from if eligible or whether it is explicitly opted out from being associated and consuming capacity from any reserved capacity available in the subscription. Minimum api-version: 2026-04-01. |
|
| computerName |
string |
Specifies the host OS name of the virtual machine. |
| disks |
The disks information. |
|
| extensions |
The extensions information. |
|
| hyperVGeneration |
The hypervisor generation of the Virtual Machine [V1, V2] |
|
| interconnectInstanceView |
The Interconnect runtime view of the Scale Set VM instance. Minimum api-version: 2026-03-01. |
|
| maintenanceRedeployStatus |
The Maintenance Operation status on the virtual machine. |
|
| osName |
string |
The Operating System running on the hybrid machine. |
| osVersion |
string |
The version of Operating System running on the hybrid machine. |
| placementGroupId |
string |
The placement group in which the VM is running. If the VM is deallocated it will not have a placementGroupId. |
| platformFaultDomain |
integer (int32) |
The Fault Domain count. |
| platformUpdateDomain |
integer (int32) |
The Update Domain count. |
| rdpThumbPrint |
string |
The Remote desktop certificate thumbprint. |
| statuses |
The resource status information. |
|
| vmAgent |
The VM Agent running on the virtual machine. |
|
| vmHealth |
The health status for the VM. |